#!/usr/bin/python

import os
import sys
import getpass
import time
import traceback
import datetime
import string
import thread
import random
import xmlrpclib
import re
from common import sizeScalingFactor

clearAfterTest = True


testConfiguration1 = [("localhost", 11010, "user1", "/home/user1/", "/home/user1/p2pBackup", "/home/user1/statistics.txt", "/home/user1/dataForBackup"),
                     ("localhost", 11020, "user2", "/home/user2/", "/home/user2/p2pBackup", "/home/user2/statistics.txt", "/home/user2/dataForBackup"),
                     ("localhost", 11040, "user3", "/home/user3/", "/home/user3/p2pBackup", "/home/user3/statistics.txt", "/home/user3/dataForBackup"),
                     ("localhost", 11050, "user4", "/home/user4/", "/home/user4/p2pBackup", "/home/user4/statistics.txt", "/home/user4/dataForBackup"),
                     ("localhost", 11060, "user5", "/home/user5/", "/home/user5/p2pBackup", "/home/user5/statistics.txt", "/home/user5/dataForBackup"),
                     ("localhost", 11070, "user6", "/home/user6/", "/home/user6/p2pBackup", "/home/user6/statistics.txt", "/home/user6/dataForBackup"),
                     ("localhost", 11080, "user7", "/home/user7/", "/home/user7/p2pBackup", "/home/user7/statistics.txt", "/home/user7/dataForBackup"),
                     ("localhost", 11090, "user8", "/home/user8/", "/home/user8/p2pBackup", "/home/user8/statistics.txt", "/home/user8/dataForBackup"),
                     ("localhost", 11100, "user9", "/home/user9/", "/home/user9/p2pBackup", "/home/user9/statistics.txt", "/home/user9/dataForBackup"),
                     ("localhost", 11110, "user10", "/home/user10/", "/home/user10/p2pBackup", "/home/user10/statistics.txt", "/home/user10/dataForBackup")]

testConfiguration2 = [("red13", 60010, "krzadca", "/home/staff/iinf/krzadca/", "/tmp/user1/p2pBackup"),
                     ("red14", 60020, "krzadca", "/home/staff/iinf/krzadca/", "/tmp/user2/p2pBackup"),
                     ("red15", 60070, "krzadca", "/home/staff/iinf/krzadca/", "/tmp/user3/p2pBackup")]

testConfiguration3 = [("orange01", 60010, "ps219737", "/home/dokstud/ps219737/", "/tmp/user1/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user1"),
                     #("orange02", 60020, "ps219737", "/home/dokstud/ps219737/", "/tmp/user2/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user2"),
                     ("orange03", 60070, "ps219737", "/home/dokstud/ps219737/", "/tmp/user3/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user3"),
                     ("orange04", 60080, "ps219737", "/home/dokstud/ps219737/", "/tmp/user4/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user4"),
                     ("orange05", 60090, "ps219737", "/home/dokstud/ps219737/", "/tmp/user4/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user5"),
                     ("orange06", 60100, "ps219737", "/home/dokstud/ps219737/", "/tmp/user6/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user6"),
                     ("orange07", 60110, "ps219737", "/home/dokstud/ps219737/", "/tmp/user7/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user7"),
                     #("orange08", 60120, "ps219737", "/home/dokstud/ps219737/", "/tmp/user8/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user8"),
                     ("orange09", 60130, "ps219737", "/home/dokstud/ps219737/", "/tmp/user9/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user9"),
                     ("orange10", 60140, "ps219737", "/home/dokstud/ps219737/", "/tmp/user10/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user10"),
                     ("orange11", 60150, "ps219737", "/home/dokstud/ps219737/", "/tmp/user11/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user11"),
                     ("orange12", 60160, "ps219737", "/home/dokstud/ps219737/", "/tmp/user12/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user12"),
                     ("orange13", 60170, "ps219737", "/home/dokstud/ps219737/", "/tmp/user13/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user13"),
                     ("orange14", 60180, "ps219737", "/home/dokstud/ps219737/", "/tmp/user14/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user14"),
                     ("orange15", 60190, "ps219737", "/home/dokstud/ps219737/", "/tmp/user15/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user15"),
                     ("orange16", 60200, "ps219737", "/home/dokstud/ps219737/", "/tmp/user16/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user16"),
                     ("blue01", 60210, "ps219737", "/home/dokstud/ps219737/", "/tmp/user17/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user17"),
                     #("blue02", 60220, "ps219737", "/home/dokstud/ps219737/", "/tmp/user18/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user18"), NO LOCAL DISK
                     ("blue03", 60230, "ps219737", "/home/dokstud/ps219737/", "/tmp/user19/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user19"),
                     ("blue04", 60240, "ps219737", "/home/dokstud/ps219737/", "/tmp/user20/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user20"),
                     ("blue05", 60250, "ps219737", "/home/dokstud/ps219737/", "/tmp/user21/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user21"),
                     ("blue06", 60260, "ps219737", "/home/dokstud/ps219737/", "/tmp/user22/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user22"),
                     ("blue07", 60270, "ps219737", "/home/dokstud/ps219737/", "/tmp/user23/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user23"),
                     ("blue08", 60280, "ps219737", "/home/dokstud/ps219737/", "/tmp/user24/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user24"),
                     ("blue09", 60290, "ps219737", "/home/dokstud/ps219737/", "/tmp/user25/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user25"),
                     ("blue10", 60300, "ps219737", "/home/dokstud/ps219737/", "/tmp/user26/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user26"),
                     ("blue11", 60310, "ps219737", "/home/dokstud/ps219737/", "/tmp/user27/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user27"),
                     ("blue12", 60320, "ps219737", "/home/dokstud/ps219737/", "/tmp/user28/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user28"),
                     ("blue13", 60330, "ps219737", "/home/dokstud/ps219737/", "/tmp/user29/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user29"),
                     ("blue14", 60340, "ps219737", "/home/dokstud/ps219737/", "/tmp/user30/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user30"),
                     ("blue15", 60350, "ps219737", "/home/dokstud/ps219737/", "/tmp/user31/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user31"),
                     ("blue16", 60360, "ps219737", "/home/dokstud/ps219737/", "/tmp/user32/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user32"),
                     #("brown01", 60370, "ps219737", "/home/dokstud/ps219737/", "/tmp/user33/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user33"),
                     #("brown02", 60380, "ps219737", "/home/dokstud/ps219737/", "/tmp/user34/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user34"),
                     #("brown03", 60390, "ps219737", "/home/dokstud/ps219737/", "/tmp/user35/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user35"),
                     #("brown04", 60400, "ps219737", "/home/dokstud/ps219737/", "/tmp/user36/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user36"),
                     #("brown05", 60410, "ps219737", "/home/dokstud/ps219737/", "/tmp/user37/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user37"),
                     #("brown06", 60420, "ps219737", "/home/dokstud/ps219737/", "/tmp/user38/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user38"),
                     #("brown07", 60430, "ps219737", "/home/dokstud/ps219737/", "/tmp/user39/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user39"),
                     #("brown08", 60440, "ps219737", "/home/dokstud/ps219737/", "/tmp/user40/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user40"),
                     #("brown09", 60450, "ps219737", "/home/dokstud/ps219737/", "/tmp/user41/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user41"),
                     #("brown10", 60460, "ps219737", "/home/dokstud/ps219737/", "/tmp/user42/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user42"),
                     #("brown11", 60470, "ps219737", "/home/dokstud/ps219737/", "/tmp/user43/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user43"),
                     #("brown12", 60480, "ps219737", "/home/dokstud/ps219737/", "/tmp/user44/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user44"),
                     #("brown13", 60490, "ps219737", "/home/dokstud/ps219737/", "/tmp/user45/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user45"),
                     #("brown14", 60500, "ps219737", "/home/dokstud/ps219737/", "/tmp/user46/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user46"),
                     #("brown15", 60510, "ps219737", "/home/dokstud/ps219737/", "/tmp/user47/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user47"),
                     #("brown16", 60520, "ps219737", "/home/dokstud/ps219737/", "/tmp/user48/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user48"),
                     ("violet01", 60530, "ps219737", "/home/dokstud/ps219737/", "/tmp/user49/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user49"),
                     ("violet02", 60540, "ps219737", "/home/dokstud/ps219737/", "/tmp/user50/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user50"),
                     ("violet03", 60550, "ps219737", "/home/dokstud/ps219737/", "/tmp/user51/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user51"),
                     ("violet04", 60560, "ps219737", "/home/dokstud/ps219737/", "/tmp/user52/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user52"),
                     ("violet05", 60570, "ps219737", "/home/dokstud/ps219737/", "/tmp/user53/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user53"),
                     ("violet06", 60580, "ps219737", "/home/dokstud/ps219737/", "/tmp/user54/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user54"),
                     ("violet07", 60590, "ps219737", "/home/dokstud/ps219737/", "/tmp/user55/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user55"),
                     ("violet08", 60600, "ps219737", "/home/dokstud/ps219737/", "/tmp/user56/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user56"),
                     ("violet09", 60610, "ps219737", "/home/dokstud/ps219737/", "/tmp/user57/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user57"),
                     ("violet10", 60620, "ps219737", "/home/dokstud/ps219737/", "/tmp/user58/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user58"),
                     ("violet11", 60630, "ps219737", "/home/dokstud/ps219737/", "/tmp/user59/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user59"),
                     ("violet12", 60640, "ps219737", "/home/dokstud/ps219737/", "/tmp/user60/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user60"),
                     ("violet13", 60650, "ps219737", "/home/dokstud/ps219737/", "/tmp/user61/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user61"),
                     ("violet14", 60660, "ps219737", "/home/dokstud/ps219737/", "/tmp/user62/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user62"),
                     ("violet15", 60670, "ps219737", "/home/dokstud/ps219737/", "/tmp/user63/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user63"),
                     ("violet16", 60680, "ps219737", "/home/dokstud/ps219737/", "/tmp/user64/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user64"),
                     ("cyan01", 60690, "ps219737", "/home/dokstud/ps219737/", "/tmp/user65/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user65"),
                     ("cyan02", 60700, "ps219737", "/home/dokstud/ps219737/", "/tmp/user66/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user66"),
                     ("cyan03", 60710, "ps219737", "/home/dokstud/ps219737/", "/tmp/user67/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user67"),
                     ("cyan04", 60720, "ps219737", "/home/dokstud/ps219737/", "/tmp/user68/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user68"),
                     ("cyan05", 60730, "ps219737", "/home/dokstud/ps219737/", "/tmp/user69/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user69"),
                     ("cyan06", 60740, "ps219737", "/home/dokstud/ps219737/", "/tmp/user70/p2pBackup", "/tmp/statistics.txt", "/tmp/dataForBackup/user70")]

testConfiguration = testConfiguration1

username = getpass.getuser()

proxys = {} # this is a map from configuration machine to the proxy to MainFacade

def chooseConfiguration(configuration, num):
    print("Choosing configuration")
    myconfig = []
    pattern = re.compile("Connection")
    for machine in configuration:
        addr, port, username, homeDir, userPath, statsPath, dataForBackup = machine
        output = os.popen("ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " ls", "r")
        line = output.readline()
        if len(line) > 0:
            print("Adding " + addr + " to configuration")
            myconfig.append(machine)
        else:
            print("Peer " + addr + " is not alive")
        if len(myconfig) == num:
            return myconfig
    raise Exception("Did not found enough machines")

def prepareDataForBackup(addr, username, basePath):
    createDirectoryCommand = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " mkdir -p %s/aaa" % basePath
    os.system(createDirectoryCommand)
    fileSize1 = 20760
    fileSize2 = 20760
    fileSize3 = 20760
    fileSize4 = 20760
    fileSize5 = 20760
    fileSize6 = 20760
    fileSize7 = 20760
    fileSize8 = 20760
    fileSize9 = 20760
    fileSize10 = 20760
    createFile1Command = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " dd if=/dev/zero of=%s/aaa/file1 bs=%s count=1" % (basePath, str(random.randint(0, fileSize1)))
    createFile2Command = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " dd if=/dev/zero of=%s/aaa/file2 bs=%s count=1" % (basePath, str(random.randint(0, fileSize2)))
    createFile3Command = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " dd if=/dev/zero of=%s/aaa/file3 bs=%s count=1" % (basePath, str(random.randint(0, fileSize3)))
    createFile4Command = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " dd if=/dev/zero of=%s/aaa/file4 bs=%s count=1" % (basePath, str(random.randint(0, fileSize4)))
    createFile5Command = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " dd if=/dev/zero of=%s/aaa/file5 bs=%s count=1" % (basePath, str(random.randint(0, fileSize5)))
    createFile6Command = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " dd if=/dev/zero of=%s/aaa/file6 bs=%s count=1" % (basePath, str(random.randint(0, fileSize6)))
    createFile7Command = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " dd if=/dev/zero of=%s/aaa/file7 bs=%s count=1" % (basePath, str(random.randint(0, fileSize7)))
    createFile8Command = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " dd if=/dev/zero of=%s/aaa/file8 bs=%s count=1" % (basePath, str(random.randint(0, fileSize8)))
    createFile9Command = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " dd if=/dev/zero of=%s/aaa/file9 bs=%s count=1" % (basePath, str(random.randint(0, fileSize9)))
    createFile10Command = "ssh -f -o ConnectTimeout=1 " + username + "@" + addr + " dd if=/dev/zero of=%s/aaa/file10 bs=%s count=1" % (basePath, str(random.randint(0, fileSize10)))
    os.system(createFile1Command)
    os.system(createFile2Command)
    os.system(createFile3Command)
    os.system(createFile4Command)
    os.system(createFile5Command)
    os.system(createFile6Command)
    os.system(createFile7Command)
    os.system(createFile8Command)
    os.system(createFile9Command)
    os.system(createFile10Command)

    return basePath

def printData(basePath):
    print "TEST_LOG: " +  str(datetime.datetime.today()) + " Printing files for base path " + str(basePath)
    for dirname, dirnames, filenames in os.walk(basePath):
        for filename in filenames:
            print os.path.join(dirname, filename)
    print "TEST_LOG: " + str(datetime.datetime.today()) + " Printing files done"
    sys.stdout.flush()

def gatherStatistics(testConfiguration, regEx):
    print("Gathering Statistics")
    lines = []
    pattern = re.compile(".*" + regEx + ".*:" + "(.*)")
    maxV = None
    minV = None
    sumV = 0.0
    numV = 0
    for machine in testConfiguration:
        addr = machine[0]
        username = machine[2]
        statisticsPath = machine[5]
        localFile = os.path.basename(statisticsPath)
        absLocalFile = os.path.join(sys.path[0], localFile)
        os.system("rm -rf "+ localFile)
        cpCommand = "scp " + username + "@" + addr + ":" + statisticsPath + " ."
        os.system(cpCommand)
        if os.path.isfile(absLocalFile):
            f = open(localFile, 'r')
            for line in f:
                match = pattern.match(line)
                if match != None:
                    groups = match.groups()
                    val = float(groups[0])
                    if minV == None:
                        minV = val
                    if maxV == None:
                        maxV = val
                    minV = min(minV, val)
                    maxV = max(maxV, val)
                    sumV = sumV + val
                    numV = numV + 1
                    lines.append(str(username) + ":" + str(addr) + ": " + string.strip(line))
    print("STATISTICS FOR: " + regEx)
    for line in lines:
        print(line)
    if numV > 0:
        avgV = sumV / numV
    else:
        avgV = 0.0
    print("Average value: " + str(avgV))
    print("Number of values: " + str(numV))
    print("Minimal value: " + str(minV))
    print("Maximal value: " + str(maxV))

def killMachine(machine):
    addr = machine[0]
    port = machine[1]
    user = machine[2]
    os.system ("ssh -o ConnectTimeout=3 " + user + "@" + addr + " pkill -U " + user + " -f .*python.*")

def killMachines(testConf):
    print("Killing machines")
    for machine in testConf:
        killMachine(machine)
    
def removeMachineData(machine):
    addr = machine[0]
    port = machine[1]
    user = machine[2]
    userPath = machine[4]
    catalogPath = userPath + "/peerstorage/metadata/filesCatalog"
    statsPath = machine[5]
    dataPath = machine[6]
    command = "ssh -o ConnectTimeout=3 " + user + "@" + addr + " rm -f " + catalogPath
    os.system(command)
    os.system("rm -rf  + ~/negoServerPers-" + str(port) + " ttlMap rttMap")
    command = "ssh -o ConnectTimeout=3 " + user + "@" + addr + " rm -rf metadata " + statsPath + " " + userPath + " " + dataPath
    os.system(command)

def removeData(testConf):
    print("Removing data")
    for machine in testConf:
        removeMachineData(machine)


def disjoin(machines):
    for machine in machines:
        proxys[machine].leaveNetwork()
        killMachine(machine)

def putUpMachines(machines):
    otherIps = ""
    for machine in machines:
        addr, port, user, homeDir, userPath, statsPath, dataForBackup = machine
        if user == "user5":
            totalIncommingBwBound = 10 * sizeScalingFactor
            desiredBackWindow = 0
            myTotalSpace = 15000 * sizeScalingFactor
        else:
            totalIncommingBwBound = 10 * sizeScalingFactor
            desiredBackWindow = 0
            myTotalSpace = 100 * 1024 * 1024 * sizeScalingFactor
        command = "ssh -f -o ConnectTimeout=1 " + user + "@" + addr + " python -u '" + sys.path[0] + "/mainFacade.py " + addr + " " + \
            str(port) + " " + homeDir + " " + userPath + " " + statsPath + " " + str(totalIncommingBwBound) + " " +\
            str(desiredBackWindow) + " " + str(myTotalSpace) + " " + homeDir + "/metadata " + str(otherIps) + "'"
        os.system(command)
        otherIps += (" " + str(addr))
        otherIps += (" " + str(port))
        proxys[machine] = xmlrpclib.ServerProxy("http://" + str(addr) + ":" + str(port), allow_none = True)

        for i in range(0, 30):
            if i == 29:
                raise Exception()
            try:
                proxys[machine].isWorking()
                break
            except:
                time.sleep(1)

    val = 10
    for machine in machines:
        proxys[machine].setTotalIncommingBwBound(val * sizeScalingFactor)
        val += 10


def printReport(machines):
    for machine in machines:
        proxys[machine].printReport()  
    for machine in machines:
        proxys[machine].printFileVersions()
    for machine in machines:
        ttls = proxys[machine].getTtls()
        print str(machine)
        for name in ttls.keys():
            print "    " + str(name)
            for v in ttls[name].keys():
                print "        " + str(v) + " <- " + str(ttls[name][v])

def backup(machines):
    print "TEST: backuping directories"
    for machine in machines:
        dataForBackup = machine[6]
        proxys[machine].backupDirectory(dataForBackup)

def clearStats(machines):
    for machine in machines:
        addr, port, user, homeDir, userPath, statsPath, dataForBackup = machine
        os.system ("ssh -o ConnectTimeout=3 " + user + "@" + addr + " rm -rf " + statsPath)

def testScalability(testConfiguration):
    backup(testConfiguration)

    time.sleep(80)
    disjoin([testConfiguration[-1]])
    time.sleep(1)

    print("Updating backup from addr: " + addr + " and port num: " + str(port))
    backup([testConfiguration[0]])

    time.sleep(20)

def simpleBackupTest(testConfiguration):
    backup(testConfiguration)

    time.sleep(200)

    print("FINISHED TEST :)")

def simpleUpdateTest(testConfiguration):
    backup(testConfiguration)
    time.sleep(1000)
    backup(testConfiguration)
    time.sleep(1000)

    print("FINISHED TEST :)")

def simpleRestoreTest(testConfiguration):
    backup(testConfiguration)
    time.sleep(400)

    machineForKill = testConfiguration[0]
    printData(machineForKill[6])
    printReport(testConfiguration)
    time.sleep(50)
    killMachine(machineForKill)
    removeMachineData(machineForKill)
    printData(machineForKill[6])
    time.sleep(100)

    addr, port, user, homeDir, userPath, statsPath, dataForBackup = machineForKill
    totalIncommingBwBound = 10 * sizeScalingFactor
    desiredBackWindow = 0
    myTotalSpace = 100 * 1024 * 1024 * sizeScalingFactor
    otherIps = ""
    command = "ssh -f -o ConnectTimeout=1 " + user + "@" + addr + " python -u '" + sys.path[0] + "/mainFacade.py " + addr + " " + \
        str(port) + " " + homeDir + " " + userPath + " " + statsPath + " " + str(totalIncommingBwBound) + " " +\
        str(desiredBackWindow) + " " + str(myTotalSpace) + " " + homeDir + "/metadata " + str(otherIps) + "'"
    os.system(command)
    print "TEST_LOG: Machine restarted"
    sys.stdout.flush()

    time.sleep(400)
    printData(machineForKill[6])

    print("FINISHED TEST :)")

def testAsyncMessages(testConfiguration, samples, killedMachinesNum):
    backup(testConfiguration)

    time.sleep(80)

    clearStats(testConfiguration)
    time.sleep(2)

    for m in range(samples):
        machinesForKill = random.sample(testConfiguration, killedMachinesNum)
        machinesAlive = []
        for machine in testConfiguration:
            if machine not in machinesForKill:
                machinesAlive.append(machine)

        for machine in machinesForKill:
            addr, port, user, homeDir, userPath, statsPath, dataForBackup = machine
            print(str(datetime.datetime.now()) + " MACHINE TO KILL: " + str(addr) + " : " + str(user))

        print("Machines for kill: " + str(machinesForKill))
        disjoin(machinesForKill)
        time.sleep(1)

        print("Updating backup from addr: ")
        for machine in machinesAlive:
            print(str(machine))
        backup(machinesAlive)

        time.sleep(15)

        join(machinesForKill)

        time.sleep(4)


testConfiguration = chooseConfiguration(testConfiguration, 7)

try:
    removeData(testConfiguration)

    for machine in testConfiguration:
        addr, port, user, homeDir, userPath, statsPath, dataForBackup = machine
        prepareDataForBackup(addr, user, dataForBackup)

    print("Starting test")

    time.sleep(1)
        
    putUpMachines(testConfiguration)

    time.sleep(10)

    #testAsyncMessages(testConfiguration, 2, 1)
    #simpleUpdateTest(testConfiguration)
    #simpleBackupTest(testConfiguration)
    simpleRestoreTest(testConfiguration)

    printReport(testConfiguration)

    time.sleep(10)
except:
    traceback.print_exc()

finally:
    if clearAfterTest:
        killMachines(testConfiguration)

    gatherStatistics(testConfiguration, "success-backup")

    if clearAfterTest:
        removeData(testConfiguration)
    
