#! /usr/bin/env python

import shelve

configurationFileName = "configuration-persistent-data"

machines = shelve.open(configurationFileName, writeback=True)

class Machine:
    def __init__(self):
        self.machineName = ""
        self.hostname = ""
        self.port = ""
        self.username = ""
        self.homeDir = ""
        self.storageDir = ""
        self.daemonized = False
        self.directoriesForBackup = []
        self.mainPath = ""
        self.totalIncommingBwBound = 1
        self.desiredBackWindow = 0
        self.totalSpace = 1000

testConfiguration = [("localhost", 11010, "user1", "/home/user1/", "/home/user1/p2pBackup", "/home/user1/statistics.txt", "/home/user1/dataForBackup"),
                     ("localhost", 11020, "user2", "/home/user2/", "/home/user2/p2pBackup", "/home/user2/statistics.txt", "/home/user2/dataForBackup"),
                     ("localhost", 11040, "user3", "/home/user3/", "/home/user3/p2pBackup", "/home/user3/statistics.txt", "/home/user3/dataForBackup"),
                     ("localhost", 11050, "user4", "/home/user4/", "/home/user4/p2pBackup", "/home/user4/statistics.txt", "/home/user4/dataForBackup"),
                     ("localhost", 11060, "user5", "/home/user5/", "/home/user5/p2pBackup", "/home/user5/statistics.txt", "/home/user5/dataForBackup"),
                     ("localhost", 11070, "user6", "/home/user6/", "/home/user6/p2pBackup", "/home/user6/statistics.txt", "/home/user6/dataForBackup"),
                     ("localhost", 11080, "user7", "/home/user7/", "/home/user7/p2pBackup", "/home/user7/statistics.txt", "/home/user7/dataForBackup"),
                     ("localhost", 11090, "user8", "/home/user8/", "/home/user8/p2pBackup", "/home/user8/statistics.txt", "/home/user8/dataForBackup"),
                     ("localhost", 11100, "user9", "/home/user9/", "/home/user9/p2pBackup", "/home/user9/statistics.txt", "/home/user9/dataForBackup"),
                     ("localhost", 11110, "user10", "/home/user10/", "/home/user10/p2pBackup", "/home/user10/statistics.txt", "/home/user10/dataForBackup")]

i = 0
for m in testConfiguration:
    i += 1
    machine = Machine()
    machine.machineName = m[2]
    machine.hostname = m[0]
    machine.port = str(m[1])
    machine.username = m[2]
    machine.homeDir = m[3]
    machine.storageDir = m[4]
    machine.daemonized = False
    machine.directoriesForBackup = [m[6]]
    machine.mainPath = machine.homeDir + "/code"
    machine.totalIncommingBwBound = str(i * 10)
    machine.desiredBackWindow = str(0)
    machine.totalSpace = str(100 * 1024 * 1024)
    machines[machine.machineName] = machine

machines.sync()
