import logging
import traceback
import config
from datetime import datetime

if config.enviroment == "home":
    logToFile = False
    tracebacksOn = True
    commonErrOn = False
elif config.enviroment == "planetLab":
    logToFile = True
    tracebacksOn = True
    commonErrOn = True
else:
    logToFile = True
    tracebacksOn = False
    commonErrOn = False

if config.enviroment == "home":
    level = logging.DEBUG
    #level = logging.INFO
    #level = logging.WARNING
    #level = logging.ERROR
    #level = logging.CRITICAL
elif config.enviroment == "planetLab":
    level = logging.DEBUG
    #level = logging.INFO
    #level = logging.WARNING
    #level = logging.ERROR
    #level = logging.CRITICAL
else:
    #level = logging.DEBUG
    #level = logging.INFO
    level = logging.WARNING
    #level = logging.ERROR
    #level = logging.CRITICAL

class LogWrapper():
    def write(self, s):
        error(s.rstrip()) 

username = None
logWrapper = None

def init_to_file(loggingFilename, user):
    global username
    global logWrapper
    global level
    logWrapper = LogWrapper()
    logging.basicConfig(filename=loggingFilename, level=level)
    username = user

def close():
    pass

def error(msg):
    global username
    if logToFile:
        logging.error(str(username) + " "  + str(datetime.today()) + ": " + msg)
    else:
        if (level == logging.DEBUG) or (level == logging.INFO) or (level == logging.WARNING) or (level == logging.ERROR):
            print "ERROR: " + str(username) + " "  + str(datetime.today()) + ": " + msg

def info(msg):
    global username
    if logToFile:
        logging.info(str(username) + " "  + str(datetime.today()) + ": " + msg)
    else:
        if (level == logging.DEBUG) or (level == logging.INFO):
            print "INFO: " + str(username) + " "  + str(datetime.today()) + ": " + msg

def debug(msg):
    global username
    if logToFile:
        logging.debug(str(username) + " "  + str(datetime.today()) + ": " + msg)
    else:
        if (level == logging.DEBUG):
            print "DEBUG: " + str(username) + " "  + str(datetime.today()) + ": " + msg

def trace(err):
    if tracebacksOn:
        global logWrapper
        traceback.print_exc(file=logWrapper)
        logWrapper.write(str(err))

def commonErr(err):
    if commonErrOn:
        global logWrapper
        traceback.print_exc(file=logWrapper)
        logWrapper.write(str(err))

