#! /usr/bin/env python
import xmlrpclib
import logs
import traceback
from time import time

class PeerDescriptor:
    """
    This class describes public data about peer that are stored in DHT    
    """
    def __init__(self, dhtAddress = None, peerId = None):
        """Initializes PeerDescriptor by (optionally) downloading data from dht
        """

        #current use is that the real address of the peer (e.g., in NegoClient: str(remotePeer.ipAddress) + ":" + str(remotePeer.portNumber)
        #TODO: some abstraction on making connections to a peer; or maybe not, as only NegoClient will make such connections
        self.ipAddress = None
        self.portNumber = None
        self.username = None
        self.publicKey = None
        self.dataDir = None
        self.unusedDiskSpace = 10 * 1024 * 1024
        self.availability = None
        self.availabilityTimestamp = None
        self.availabilityMeasurementDuration = None
        self.totalIncommingSize = None
        self.totalIncommingBwBound = None
        self.lastReport = 0;
        self.dataReplicated = 0
        self.metadataLocations = []

        if (dhtAddress != None):
            proxy = xmlrpclib.ServerProxy(dhtAddress, allow_none=True)
            dhtResult = proxy.get(str(peerId))
            for fieldName in self.__dict__.keys():
                if dhtResult.has_key(fieldName):
                    self.__dict__[fieldName] = dhtResult[fieldName]

    

    def __str__(self):
        return "PeerDescriptorInstance: "+str(self.__dict__)
